leo65535 commented on a change in pull request #912:
URL: 
https://github.com/apache/incubator-seatunnel/pull/912#discussion_r778514172



##########
File path: tools/dependencies/checkLicense.sh
##########
@@ -0,0 +1,37 @@
+#!/usr/bin/env bash
+
+#
+# Licensed to the Apache Software Foundation (ASF) under one or more
+# contributor license agreements.  See the NOTICE file distributed with
+# this work for additional information regarding copyright ownership.
+# The ASF licenses this file to You under the Apache License, Version 2.0
+# (the "License"); you may not use this file except in compliance with
+# the License.  You may obtain a copy of the License at
+#
+#    http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+mkdir seatunnel-dependencies || true
+mvn dependency:copy-dependencies -DincludeScope=runtime 
-DoutputDirectory=seatunnel-dependencies
+
+# List all modules(jars) that belong to the DolphinScheduler itself, these 
will be ignored when checking the dependency
+# licenses
+echo '=== Self modules: ' && mvn --batch-mode --quiet -Dexec.executable='echo' 
-Dexec.args='${project.artifactId}-${project.version}.jar' exec:exec | tee 
self-modules.txt
+
+echo '=== Distributed dependencies: ' && find seatunnel-dependencies -name 
"*.jar" -exec basename {} \; | sort | uniq | tee all-dependencies.txt
+
+# Exclude all self modules(jars) to generate all third-party dependencies
+echo '=== Third party dependencies: ' && grep -vf self-modules.txt 
all-dependencies.txt | sort | uniq | tee third-party-dependencies.txt
+
+# 1. Compare the third-party dependencies with known dependencies, expect that 
all third-party dependencies are KNOWN
+# and the exit code of the command is 0, otherwise we should add its license 
to LICENSE file and add the dependency to
+# known-dependencies.txt. 2. Unify the `sort` behaviour: here we'll sort them 
again in case that the behaviour of `sort`
+# command in target OS is different from what we used to sort the file 
`known-dependencies.txt`, i.e. "sort the two file
+# using the same command (and default arguments)"
+
+diff -w -B -U0 <(sort < tools/dependencies/known-dependencies.txt) <(sort < 
third-party-dependencies.txt)

Review comment:
       we need add following files to `.gitignore`.
   ```
   all-dependencies.txt
   self-modules.txt
   third-party-dependencies.txt
   ```




-- 
This is an automated message from the Apache Git Service.
To respond to the message, please log on to GitHub and use the
URL above to go to the specific comment.

To unsubscribe, e-mail: [email protected]

For queries about this service, please contact Infrastructure at:
[email protected]


Reply via email to